;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Flurry, from SMB2 (SMUSA)
;
;Extra Bit: No
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Extra Property 1
;0 - can be killed by spin jump
;1 - can be carried
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

			incsrc xkas_def.asm

TileMap:		db $84,$86
Property:		db $4F,$0F

MaxSpeed:		db $18,$E8
SpeedTable:		db $01,$FF

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; INIT and MAIN JSL targets
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

			print "MAIN ",pc
MAIN:			PHB
			PHK
			PLB
			CMP #$09
			BCS .IsCarried
			JSR SpriteMain
			PLB
			RTL
.IsCarried		LDA $9D
			BNE .IsCarried2
			INC $1570,x
			LDA $14C8,x
			CMP #$09
			BNE .IsCarried2
			LDA $1588,x
			AND #$04
			BEQ .IsCarried2
			LDA #$E0
			STA $AA,x
			INC $1504,x
			LDA $1504,x
			CMP #$02
			BNE .IsCarried2
			LDA #$08
			STA $14C8,x
			STZ $AA,x
.IsCarried2		PHX
			PHX
			LDY $15EA,x
			LDA $1570,x
			LSR #$03
			AND #$01
			TAX
			LDA.w TileMap,x
			STA $0302,y
			PLX
			LDA $157C,x
			TAX
			LDA $0303,y
			AND #$30
			ORA.w Property,x
			ORA #$80
			STA $0303,y
			PLX
			PLB
print "INIT ",pc
			RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SPRITE_ROUTINE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Return:			RTS
SpriteMain:		JSR SpriteGraphic

			LDA $9D
			BNE Return
			LDA $14C8,x
			CMP #$08
			BNE Return
			INC $1570,x
			JSR !SubOffScreen

			JSL $81802A
			LDA $1588,x
			BIT #$03
			BEQ .SidesCheck
			PHA
			LDA $B6,x
			EOR #$FF
			INC A
			STA $B6,x
			PLA

.SidesCheck		AND #$04
			BNE .OnGround
			STZ $157C,x
			LDA $B6,x
			BPL $03
			INC $157C,x
			LDA $1570,x
			AND #$01
			BNE .Interact
			LDA $157C,x
			EOR #$01
			TAY
			LDA $B6,x
			BEQ .Interact
			BRA .AdjustSpeed
.OnGround		LDY #$00
			LDA $94
			CMP $E4,x
			LDA $95
			SBC $14E0,x
			BPL $01
			INY
			TYA
			STA $157C,x
			LDA $1570,x
			LSR A
			BCS .SpeedUpdate
			LSR A
			BCC .Interact
.SpeedUpdate		LDA $B6,x
			CMP.w MaxSpeed,y
			BEQ .Interact
.AdjustSpeed		CLC
			ADC.w SpeedTable,y
			STA $B6,x

.Interact		LDY #$B9
			LDA $1490			; Star timer
			BNE .DeafaultInteraction
			LDA $7FAB28,x
			AND #$01
			AND $140D
			BEQ .StoreTo167A
.DeafaultInteraction	LDY #$39
.StoreTo167A		TYA	
			STA $167A,x
			JSL $81803A			; both sprite and Mario intraction
			BCC .R
			LDA $14C8,x
			CMP #$08
			BNE .R
			PHK
			PER .R
			PEA $8020
			JML $81B45C
.R			RTS

			BCC .SpriteWins
			LDA $7FAB28,x			; | Is the sprite carryable?
			AND #$02			; |
			BEQ .MarioWins			;/
			BIT $16
			BVC .MarioWins
			LDA #$0B
			STA $14C8,x
			STZ $1540,x
			STZ $1504,x			; times the sprite bounced
			LDA #$99
			STA $167A,x
			RTS

.MarioWins		LDA #$08
			STA $154C,x
			RTS
.SpriteWins		LDA $154C,x
			BNE .R
			JSL $80F5B7
			RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Sprite's Graphic
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SpriteGraphic:		JSR !GetDrawInfo

			LDA $1570,x
			LSR #$03
			AND #$01
			STA $03
			LDA $157C,x
			STA $02

			PHX
			LDA $00
			STA $0300,y
			LDA $01
			STA $0301,y
			LDX $03
			LDA.w TileMap,x
			STA $0302,y
			LDX $02
			LDA.w Property,x
			ORA $64
			STA $0303,y
			PLX
			LDY #$02
			LDA #$00
			JSL $81B7B3
			RTS