;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Gusty from YI
;
;Uses first extra bit: YES
;Clear	:
;Set	: Faster
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

			incsrc definition.asm

;;;;;;;;;;;;;;;;;;;;;;;;;
;Sprite data		;
;;;;;;;;;;;;;;;;;;;;;;;;;

MAX_X_SPEED		dcb $30,$D0
			dcb $40,$C0
SPEED_TABLE		dcb $01,$FF

;;;;;;;;;;;;;;;;;;;;;;;;;
;INIT & MAIN		;
;;;;;;;;;;;;;;;;;;;;;;;;;

			dcb "INIT"
			STZ $157C,x
			LDA $94
			CMP $E4,x
			LDA $95
			SBC $14E0,x
			BPL INIT_END
			INC $157C,x
INIT_END		RTL

			dcb "MAIN"
			PHB
			PHK
			PLB
			JSR SPRITE_ROUTINE
			JSR SPRITE_GFX
			PLB
			RTL

;;;;;;;;;;;;;;;;;;;;;;;;;
;Main sprite routine	;
;;;;;;;;;;;;;;;;;;;;;;;;;

SPRITE_ROUTINE		LDA $14C8,x
			CMP #$08
			BNE RETURN
			LDA $9D
			BNE RETURN
			JSR SubOffScreen

			INC $1570,x

			LDA $7FAB10,x
			AND #$04
			LSR A
			ORA $157C,x
			TAY
			LDA $B6,x
			CMP MAX_X_SPEED,y
			BEQ FINAL
			LDY $157C,x
			LDA $B6,x
			CLC
			ADC SPEED_TABLE,y
			STA $B6,x
FINAL			JSL $018022
			JSL $01A7DC

RETURN			RTS

;;;;;;;;;;;;;;;;;;;;;;;;;
;Sprite GFX		;
;;;;;;;;;;;;;;;;;;;;;;;;;

TILE_MAP		dcb $46,$48,$58,$49,$59
			dcb $46,$48,$58,$4A,$5A
			dcb $46,$48,$58,$4B,$5B
			dcb $46,$48,$58,$4C,$5C

TILE_VERT		dcb $FF,$00,$08,$01,$09
			dcb $00,$FF,$07,$00,$08
			dcb $01,$00,$08,$FF,$07
			dcb $00,$01,$09,$00,$08

TILE_HORZ		dcb $10,$08,$08,$00,$00
			dcb $00,$10,$10,$18,$18

TILE_SIZE		dcb $02,$00,$00,$00,$00
TILE_PROP		dcb $40,$00

SPRITE_GFX		JSR GetDrawInfo

			LDA $1570,x
			LSR A
			LSR A
			AND #$03
			STA $03
			ASL A
			ASL A
			CLC
			ADC $03
			STA $03

			PHX
			LDX #$04
GFX_LOOP		PHX

			PHY
			TYA
			LSR A
			LSR A
			TAY
			LDA TILE_SIZE,x
			STA $0460,y
			PLY

			PHX
			PHY
			LDY TILE_HORZ,x
			PHX
			LDX $15E9
			LDA $157C,x
			PLX
			CMP #$00
			BEQ NO_FLIP_HORZ
			TXA
			CLC
			ADC #$05
			TAX
			LDY TILE_HORZ,x
NO_FLIP_HORZ		TYA
			CLC
			ADC $00
			PLY
			STA $0300,y
			PLX

			PHX
			TXA
			CLC
			ADC $03
			TAX
			LDA $01
			CLC
			ADC TILE_VERT,x
			STA $0301,y

			LDA TILE_MAP,x
			STA $0302,y
			PLX

			PHY
			LDX $15E9
			LDY $157C,x
			LDA TILE_PROP,y
			ORA $15F6,x
			ORA $64
			PLY
			STA $0303,y

			INY
			INY
			INY
			INY

			PLX
			DEX
			BPL GFX_LOOP

			PLX
			LDY #$FF
			LDA #$04
			JSL $01B7B3
			RTS