;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Missile bill from SMB3
;
;Uses first extra bit: YES
;Clear	:unlimited turn
;Set	:single turn
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

			incsrc definition.asm

;;;;;;;;;;;;;;;;;;;;;;;;;
;Sprite data		;
;;;;;;;;;;;;;;;;;;;;;;;;;

TILE_MAP		= $A6
TILE_PROP		dcb $02,$08

X_SPEED			dcb $20,$E0
SPEED_TABLE		dcb $FF,$01

;;;;;;;;;;;;;;;;;;;;;;;;;
;INIT & MAIN		;
;;;;;;;;;;;;;;;;;;;;;;;;;

			dcb "INIT"
			PHB
			PHK
			PLB
			JSR SUB_HORZ_POS
			TYA
			STA $157C,x
			LDA X_SPEED,y
			STA $B6,x
			LDA #$0C
			STA $163E,x
			PLB
			RTL

			dcb "MAIN"
			PHB
			PHK
			PLB
			JSR SPRITE_ROUTINE
			PLB
			RTL

;;;;;;;;;;;;;;;;;;;;;;;;;
;SPRITE_ROUTINE		;
;;;;;;;;;;;;;;;;;;;;;;;;;

SPRITE_ROUTINE		LDA $64
			PHA
			LDA $163E,x
			BEQ GFX_ROUTINE
			LDA #$10
			STA $64
GFX_ROUTINE		JSR SPRITE_GFX
			PLA
			STA $64

			LDA $14C8,x
			CMP #$08
			BNE RETURN
			LDA $9D
			BNE RETURN
			JSR SubOffScreen

			LDA $1602,x
			DEC A
			BEQ SPEED_DOWN
			BPL UPDATE

			JSR SUB_HORZ_POS
			TYA
			CMP $157C,x
			BEQ UPDATE
			INC $1602,x

UPDATE			JSL $018022
			JSL $01A7DC
RETURN			RTS

SPEED_DOWN		TXA
			EOR $14
			AND #$01
			BNE UPDATE
			LDY $157C,x
			LDA $B6,x
			CLC
			ADC SPEED_TABLE,y
			STA $B6,x
			PHA
			TYA
			EOR #$01
			TAY
			PLA
			CMP X_SPEED,y
			BNE UPDATE
			TYA
			STA $157C,x
			LDA $7FAB10,x
			AND #$04
			LSR A
			STA $1602,x
			BRA UPDATE

;;;;;;;;;;;;;;;;;;;;;;;;;
;SPRITE_GFX		;
;;;;;;;;;;;;;;;;;;;;;;;;;

SPRITE_GFX		JSR GetDrawInfo

			STZ $02
			LDA $B6,x
			BPL GFX_LABEL00
			INC $02

GFX_LABEL00		TXA
			EOR $13
			LSR A
			AND #$01
			STA $03

			PHX

			LDA $00
			STA $0300,y

			LDA $01
			STA $0301,y

			LDA #TILE_MAP
			STA $0302,y

			LDX $03
			LDA TILE_PROP,x
			LDX $02
			BNE NO_FLIP
			ORA #$40
NO_FLIP			ORA $64
			STA $0303,y

			PLX
			LDY #$02
			LDA #$00
			JSR $81B7B3
			RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB_HORZ_POS
; This routine determines which side of the sprite Mario is on.  It sets the Y register
; to the direction such that the sprite would face Mario
; It is ripped from $03B817
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_HORZ_POS		LDY #$00
			LDA $94
			CMP $E4,x
			LDA $95
			SBC $14E0,x
			BPL SPR_L16
			INY
SPR_L16			RTS