;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Stretch, from SMB3
;
;Uses first extra bit: YES
;Clear	:rises from the top of the platform
;Set	:rises from the bottom of the platform
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

			incsrc definition.asm

;;;;;;;;;;;;;;;;;;;;;;;;;
;SPRITE_DATA		;
:::::::::::::::::::::::::

TIME_TO_MOVE		dcb $28,$70

X_SPEED			dcb $10,$F0
POS_TABLE		dcb $0C,$F4
POS_TABLE2		dcb $00,$FF
TILE_MAP		dcb $E0,$E2,$E4,$E6
TILE_PROP		dcb $77,$37

ORIG_Y_LOW		= $1504
ORIG_Y_HIGH		= $151C

Y_POSITION		dcb $F4,$F7,$FA,$FD
			dcb $0A,$07,$04,$01

;;;;;;;;;;;;;;;;;;;;;;;;;
;INIT & MAIN		;
;;;;;;;;;;;;;;;;;;;;;;;;;

			dcb "INIT"
			LDA $7FAB10,x
			AND #$04
			STA $1534,x
			LDA $D8,x
			STA ORIG_Y_LOW,x
			LDA $14D4,x
			STA ORIG_Y_HIGH,x
			LDY #$00
			LDA $94
			CMP $E4,x
			LDA $95
			SBC $14E0,x
			BPL INIT_END
			INY
INIT_END		TYA
			STA $157C,x
			LDA #$10
			STA $1540,x
			RTL

			dcb "MAIN"
			PHB
			PHK
			PLB
			JSR SPRITE_ROUTINE
			JSR SPRITE_GFX
			PLB
			RTL

;;;;;;;;;;;;;;;;;;;;;;;;;
;SPRITE_ROUTINE		;
;;;;;;;;;;;;;;;;;;;;;;;;;

SPRITE_ROUTINE		LDA $14C8,x
			CMP #$08
			BNE MODE_1_RETURN
			LDA $9D
			BNE MODE_1_RETURN
			JSR SubOffScreen
			JSL $818022
			LDY $157C,x
			LDA X_SPEED,y
			STA $B6,x

			LDA $C2,x
			BNE MODE_2
			LDA #$03
			STA $1602,x
MODE_1_FINAL		LDY $157C,x
			LDA $D8,x
			PHA
			LDA $14D4,x
			PHA
			LDA ORIG_Y_LOW,x
			STA $D8,x
			LDA ORIG_Y_HIGH,x
			STA $14D4,x
			LDA $E4,x
			PHA
			CLC
			ADC POS_TABLE,y
			STA $E4,x
			LDA $14E0,x
			PHA
			ADC POS_TABLE2,y
			STA $14E0,x
			JSL $819138
			LDA $1860
			CMP #$40
			BNE DIR_CHANGE
			LDA $1862
			DEC A
			BEQ OBJ_END
DIR_CHANGE		LDA $157C,x
			EOR #$01
			STA $157C,x
OBJ_END			PLA
			STA $14E0,x
			PLA
			STA $E4,x
			PLA
			STA $14D4,x
			PLA
			STA $D8,x
			LDA $1540,x
			BNE MODE_1_RETURN
			LDA #$1F
			LDY $C2,x
			BEQ MODE_1_1540
			AND #$0F
MODE_1_1540		STA $1540,x
			INC $C2,x
MODE_1_RETURN		RTS

MODE_2			PHA
			JSL $81A7DC
			PLA
			AND #$01
			BEQ MODE_1_FINAL
			STZ $B6,x
			LDA #$FF
			STA $01
			PHP
			LDY $C2,x
			LDA $1540,x
			BNE MODE_2_B
			PLP
			TYA
			STA $1602,x
			STA $01
			INC A
			AND #$03
			STA $C2,x
			LSR A
			PHY
			TAY
			LDA TIME_TO_MOVE,y
			STA $1540,x
			PLY
			PHP
MODE_2_B		DEY
			BEQ MODE_2_A
			EOR #$18
MODE_2_A		LSR A
			LSR A
			LSR A
			PLP
			BPL MODE_2_E
			STA $1602,x
MODE_2_E		ORA $1534,x
			TAY
			LDA $01
			BMI MODE_2_D
			ORA $1534,x
			TAY
MODE_2_D		STZ $00
			LDA Y_POSITION,y
			BPL MODE_2_C
			DEC $00
MODE_2_C		CLC
			ADC ORIG_Y_LOW,x
			STA $D8,x
			LDA ORIG_Y_HIGH,x
			ADC $00
			STA $14D4,x
RETURN			RTS

;;;;;;;;;;;;;;;;;;;;;;;;;
;SPRITE_GFX		;
;;;;;;;;;;;;;;;;;;;;;;;;;

SPRITE_GFX		LDA $C2,x
			BEQ RETURN
			JSR GetDrawInfo

			PHX
			LDA $1534,x
			PHA
			LDA $157C,x
			PHA
			LDA $1602,x
			PHA

			REP #$20
			LDA $00
			STA $0300,y
			SEP #$20
			PLX
			LDA TILE_MAP,x
			STA $0302,y
			PLX
			LDA TILE_PROP,x
			PLX
			BEQ STORE_0303
			ORA #$80
STORE_0303		STA $0303,y

			PLX
			LDY #$02
			LDA #$00
			JSL $81B7B3
			RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB_HORZ_POS
; This routine determines which side of the sprite Mario is on.  It sets the Y register
; to the direction such that the sprite would face Mario
; It is ripped from $03B817
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_HORZ_POS		LDY #$00
			LDA $94
			SEC
			SBC $E4,x
			STA $0F
			LDA $95
			SBC $14E0,x
			BPL SPR_L16
			INY
SPR_L16			RTS